///////////////////////////////////////////////////////////////////////
//
//  SCHEDVBX.H - Schedule/VBX Visual Basic Custom Control by ADDSoft, Inc.
//					Version 1.00
//
///////////////////////////////////////////////////////////////////////

#ifndef __SCHEDVBX_H__
#define __SCHEDVBX_H__

#include <afxext.h>

#define VBM_BASE 		(WM_USER  + 0x0c00)
#define VBM_INITPROPUP	(VBM_BASE + 0x09)

#define IPROP_CTLNAME                   0
#define IPROP_INDEX                     1
#define IPROP_LEFT                      2
#define IPROP_TOP                       3
#define IPROP_WIDTH                     4
#define IPROP_HEIGHT                    5
#define IPROP_VISIBLE                   6
#define IPROP_PARENT                    7
#define IPROP_HWND                      8
#define IPROP_TAG                       9
#define IPROP_CAPTION                   10
#define IPROP_BORDERSTYLE               11
#define IPROP_TABINDEX                  12
#define IPROP_TABSTOP                   13
#define IPROP_BACKCOLOR					14
#define IPROP_DUMMY1					15
#define IPROP_DUMMY2					16
#define IPROP_DUMMY3					17
#define IPROP_MASTERDIALOG              18
#define IPROP_GENERALDIALOG             19
#define IPROP_ABOUT                     20
#define IPROP_DISPLAYMODE				21
#define IPROP_BEVELHIGHLIGHTCOLOR       22
#define IPROP_BEVELSHADOWCOLOR          23
#define IPROP_BEVELWIDTH                24
#define IPROP_GRIDMAJORCOLOR            25
#define IPROP_GRIDMAJORTHICKNESS        26
#define IPROP_HINSTANCE					27
#define IPROP_PROCESSTAB				28
#define IPROP_DOUBLECLICKDIVIDE			29
#define IPROP_REDRAW					30
#define IPROP_SCROLLBARCOLOR            31
#define IPROP_SCROLLBARWIDTH            32
#define IPROP_PROPERTYLOAD				33
#define IPROP_PROPERTYSAVE				34
#define IPROP_DATETIMEDIALOG			35
#define IPROP_CURRENTTIMECOLOR          36
#define IPROP_CURRENTTIMELINE           37
#define IPROP_DEFAULTDATETIMEFORMAT		38
#define IPROP_DEFAULTDURATIONFORMAT		39
#define IPROP_TSDIALOG          		40
#define IPROP_TSTHUMBWINDOW				41
#define IPROP_TSBACKCOLOR               42
#define IPROP_TSBEVEL                   43
#define IPROP_TSGRIDCOLOR               44
#define IPROP_TSGRIDTHICKNESS           45
#define IPROP_TSMAJORPERCENT			46
#define IPROP_TSNUMMINORTICKS			47
#define IPROP_TSSIZETOTICK				48
#define IPROP_TSSIZE					49
#define IPROP_TSMAJOR                   50
#define IPROP_TSMAJORCOUNT              51
#define IPROP_TSMAJORFONTCOLOR          52
#define IPROP_TSMAJORFONTNAME           53
#define IPROP_TSMAJORFONTSIZEPERCENT	54
#define IPROP_TSMAJORFONTBOLD           55
#define IPROP_TSMAJORFONTITALIC         56
#define IPROP_TSMAJORFONTORIENT			57
#define IPROP_TSMAJORFORMAT             58
#define IPROP_TSMAJORGRID               59
#define IPROP_TSMINOR                   60
#define IPROP_TSMINORCOUNT              61
#define IPROP_TSMINORFONTCOLOR          62
#define IPROP_TSMINORFONTNAME           63
#define IPROP_TSMINORFONTSIZEPERCENT    64
#define IPROP_TSMINORFONTBOLD           65
#define IPROP_TSMINORFONTITALIC         66
#define IPROP_TSMINORFONTORIENT			67
#define IPROP_TSMINORFORMAT             68
#define IPROP_TSMINORGRID               69
#define IPROP_TSRULERLARGE				70
#define IPROP_TSRULERSMALL				71
#define IPROP_TSRULERCOLOR				72
#define IPROP_TSDATETIMEBEG             73
#define IPROP_TSDATETIMEEND             74
#define IPROP_TSDATETIMEVIEW            75
#define IPROP_BARSDIALOG                76
#define IPROP_BARSMAX					77
#define IPROP_BARMOVETEXTFORMAT			78
#define IPROP_BARNAME					79
#define IPROP_BARSIZE					80
#define IPROP_BAROFFSET					81
#define IPROP_BARCOLOR                  82
#define IPROP_BARPATTERN                83
#define IPROP_BARADJUSTABLE				84
#define IPROP_BARTEXTPOSITION			85
#define IPROP_BARTEXTFIELD              86
#define IPROP_BARTEXTFORMAT             87
#define IPROP_BARTEXTCLIP				88
#define IPROP_BARFONTCOLOR				89
#define IPROP_BARFONTNAME				90
#define IPROP_BARFONTSIZEPERCENT		91
#define IPROP_BARFONTBOLD				92
#define IPROP_BARFONTITALIC				93
#define IPROP_BARBEGSYMBOL              94
#define IPROP_BARBEGTYPE                95
#define IPROP_BARBEGCOLOR               96
#define IPROP_BARBEGSIZE				97
#define IPROP_BARBEGOFFSET              98
#define IPROP_BARENDSYMBOL              99
#define IPROP_BARENDTYPE                100
#define IPROP_BARENDCOLOR               101
#define IPROP_BARENDSIZE				102
#define IPROP_BARENDOFFSET              103
#define IPROP_BARDELETE					104
#define IPROP_BARINSERT					105
#define IPROP_RESHDRDIALOG				106
#define IPROP_RESHDRHEIGHT				107
#define IPROP_RESHDRBACKCOLOR			108
#define IPROP_RESHDRBEVEL				109
#define IPROP_RESHDRFONTCOLOR			110
#define IPROP_RESHDRFONTNAME			111
#define IPROP_RESHDRFONTSIZEPERCENT		112
#define IPROP_RESHDRFONTBOLD			113
#define IPROP_RESHDRFONTITALIC			114
#define IPROP_RESHDRGRIDCOLOR			115
#define IPROP_RESHDRGRIDTHICKNESS		116
#define IPROP_RESHDRRESIZE				117
#define IPROP_RESCOLDIALOG              118
#define IPROP_RESCOLMAX                 119
#define IPROP_RESCOLFIELD               120
#define IPROP_RESCOLFORMAT              121
#define IPROP_RESCOLLABEL               122
#define IPROP_RESCOLWIDTH               123
#define IPROP_RESCOLALIGNMENT           124
#define IPROP_RESCOLVISIBLE             125
#define IPROP_RESCOLFROZEN              126
#define IPROP_RESCOLEDITABLE            127
#define IPROP_RESCOLRESIZABLE           128
#define IPROP_RESDIALOG                 129
#define IPROP_RESMAX                    130
#define IPROP_RESVIEW					131
#define IPROP_RESWIDTH					132
#define IPROP_RESUNUSEDBACKCOLOR        133
#define IPROP_RESBEVEL                  134
#define IPROP_RESGRIDCOLOR              135
#define IPROP_RESGRIDTHICKNESS          136
#define IPROP_RESWIDTHRESIZE			137
#define IPROP_RESLINERESIZE				138
#define IPROP_RESCURRENTCOL             139
#define IPROP_RESCURRENTROW             140
#define IPROP_RESNAME                   141
#define IPROP_RESBARDEFAULT             142
#define IPROP_RESUSER1                  143
#define IPROP_RESUSER2                  144
#define IPROP_RESUSER3                  145
#define IPROP_RESUSER4                  146
#define IPROP_RESLINEHEIGHT             147
#define IPROP_RESBACKCOLOR              148
#define IPROP_RESFONTCOLOR              149
#define IPROP_RESFONTNAME               150
#define IPROP_RESFONTSIZEPERCENT		151
#define IPROP_RESFONTBOLD               152
#define IPROP_RESFONTITALIC             153
#define IPROP_RESCLEAR                  154
#define IPROP_RESDELETE                 155
#define IPROP_RESINSERT                 156
#define IPROP_RESISEMPTY                157
#define IPROP_RESNEXTEMPTY              158
#define IPROP_RESSORT                   159
#define IPROP_RESLOAD                   160
#define IPROP_RESSAVE                   161
#define IPROP_TBHDRDIALOG               162
#define IPROP_TBHDRBACKCOLOR            163
#define IPROP_TBHDRBEVEL                164
#define IPROP_TBHDRGRIDCOLOR            165
#define IPROP_TBHDRHEIGHT               166
#define IPROP_TBCOLDIALOG               167
#define IPROP_TBCOLMAX                  168
#define IPROP_TBCOLFIELD                169
#define IPROP_TBCOLFORMAT               170
#define IPROP_TBCOLLABEL                171
#define IPROP_TBCOLWIDTH                172
#define IPROP_TBCOLALIGNMENT            173
#define IPROP_TBCOLVISIBLE              174
#define IPROP_TBCOLFROZEN               175
#define IPROP_TBCOLEDITABLE             176
#define IPROP_TBCOLRESIZABLE            177
#define IPROP_TBDIALOG                  178
#define IPROP_TBMAX                     179
#define IPROP_TBHEIGHT                  180
#define IPROP_TBLINEHEIGHT              181
#define IPROP_TBVIEW					182
#define IPROP_TBWIDTH                   183
#define IPROP_TBBACKCOLOR               184
#define IPROP_TBBEVEL                   185
#define IPROP_TBGRIDCOLOR               186
#define IPROP_TBFONTCOLOR            	187
#define IPROP_TBFONTNAME             	188
#define IPROP_TBFONTSIZEPERCENT      	189
#define IPROP_TBFONTBOLD             	190
#define IPROP_TBFONTITALIC           	191
#define IPROP_TBRESOURCE                192
#define IPROP_TBBEG                     193
#define IPROP_TBEND                     194
#define IPROP_TBDUR                     195
#define IPROP_TBBAR                     196
#define IPROP_TBGROUP                   197
#define IPROP_TBUSER1                   198
#define IPROP_TBUSER2                   199
#define IPROP_TBUSER3                   200
#define IPROP_TBUSER4                   201
#define IPROP_TBCLEAR                   202
#define IPROP_TBCLEARRES                203
#define IPROP_TBDELETE                  204
#define IPROP_TBISEMPTY                 205
#define IPROP_TBNEXTEMPTY               206
#define IPROP_TBLOAD                    207
#define IPROP_TBSAVE                    208
#define IPROP_SCHEDDIALOG               209
#define IPROP_SCHEDBACKCOLOR            210
#define IPROP_SCHEDBEVEL                211
#define IPROP_SCHEDGRIDCOLOR            212
#define IPROP_SCHEDGRIDTHICKNESS        213
#define IPROP_LEGENDDIALOG              214
#define IPROP_LEGENDTITLE               215
#define IPROP_LEGENDPOSITION            216
#define IPROP_LEGENDTYPE                217
#define IPROP_LEGENDSIZE                218
#define IPROP_LEGENDLINEHEIGHT			219
#define IPROP_LEGENDBACKCOLOR           220
#define IPROP_LEGENDBEVEL               221
#define IPROP_LEGENDVIEW				222
#define IPROP_LEGENDSELECTION			223
#define IPROP_LEGENDRESIZE				224
#define IPROP_PRINTDIALOG				225
#define IPROP_PRINTCHART				226
#define IPROP_PRINTSCREEN				227
#define IPROP_PRINTSHOWDIALOG			228
#define IPROP_PRINTHEADER				229
#define IPROP_PRINTFOOTER				230
#define IPROP_PRINTWIDTH				231
#define IPROP_PRINTHEIGHT				232
#define IPROP_PRINTLEFTMARGIN			233
#define IPROP_PRINTTOPMARGIN			234
#define IPROP_PRINTRIGHTMARGIN			235
#define IPROP_PRINTBOTTOMMARGIN			236
#define IPROP_PRINTHEADERHEIGHT			237
#define IPROP_PRINTHEADERTEXT			238
#define IPROP_PRINTHEADERTEXTHEIGHT		239
#define IPROP_PRINTFOOTERHEIGHT			240
#define IPROP_PRINTFOOTERTEXT			241
#define IPROP_PRINTFOOTERTEXTHEIGHT		242
#define IPROP_MONTHNUMCOLOR				243
#define IPROP_MONTHNUMSIZE				244
#define IPROP_MONTHNONNUMCOLOR			245
#define IPROP_MONTHNONNUMSIZE			246

#define IEVENT_STD_DRAGDROP					0
#define IEVENT_STD_DRAGOVER					1
#define IEVENT_STD_GOTFOCUS                 2
#define IEVENT_STD_LOSTFOCUS                3
#define IEVENT_STD_MOUSEDOWN                4
#define IEVENT_STD_MOUSEMOVE                5
#define IEVENT_STD_MOUSEUP                  6
#define IEVENT_STD_KEYDOWN                  7
#define IEVENT_STD_KEYPRESS                 8
#define IEVENT_STD_KEYUP                    9
#define IEVENT_BARBEGDOUBLECLICK			10
#define IEVENT_BARBEGRIGHTDOUBLECLICK		11
#define IEVENT_BARBEGRIGHTSINGLECLICK		12
#define IEVENT_BARBEGSINGLECLICK			13
#define IEVENT_BARDOUBLECLICK				14
#define IEVENT_BARENDDOUBLECLICK			15
#define IEVENT_BARENDRIGHTDOUBLECLICK		16
#define IEVENT_BARENDRIGHTSINGLECLICK		17
#define IEVENT_BARENDSINGLECLICK			18
#define IEVENT_BARMIDDOUBLECLICK			19
#define IEVENT_BARMIDRIGHTDOUBLECLICK		20
#define IEVENT_BARMIDRIGHTSINGLECLICK		21
#define IEVENT_BARMIDSINGLECLICK			22
#define IEVENT_BARRIGHTDOUBLECLICK			23
#define IEVENT_BARRIGHTSINGLECLICK			24
#define IEVENT_BARSINGLECLICK				25
#define IEVENT_CELLDOUBLECLICK				26
#define IEVENT_CELLGOTFOCUS					27
#define IEVENT_CELLLOSTFOCUS				28
#define IEVENT_CELLRIGHTDOUBLECLICK			29
#define IEVENT_CELLRIGHTSINGLECLICK			30
#define IEVENT_CELLSINGLECLICK				31
#define IEVENT_DISPLAYMODECHANGED			32
#define IEVENT_HEADERHEIGHTCHANGED			33
#define IEVENT_INSERTMODECHANGED			34
#define IEVENT_LEGENDDOUBLECLICK			35
#define IEVENT_LEGENDSINGLECLICK			36
#define IEVENT_LEGENDSIZECHANGED			37
#define IEVENT_RESCHANGED					38
#define IEVENT_RESCOLRESIZED				39
#define IEVENT_RESHDRDOUBLECLICK			40
#define IEVENT_RESHDRRIGHTDOUBLECLICK		41
#define IEVENT_RESHDRRIGHTSINGLECLICK		42
#define IEVENT_RESHDRSINGLECLICK			43
#define IEVENT_RESHEIGHTCHANGED				44
#define IEVENT_RESSCROLLPASTBEG				45
#define IEVENT_RESSCROLLPASTEND				46
#define IEVENT_RESVIEWCHANGED				47
#define IEVENT_RESWIDTHCHANGED				48
#define IEVENT_SCHEDBACKDOUBLECLICK			49
#define IEVENT_SCHEDBACKRIGHTDOUBLECLICK	50
#define IEVENT_SCHEDBACKRIGHTSINGLECLICK	51
#define IEVENT_SCHEDBACKSINGLECLICK			52
#define IEVENT_TBBEGCHANGED					53
#define IEVENT_TBCHANGEBEGIN				54
#define IEVENT_TBCHANGED					55
#define IEVENT_TBDURCHANGED					56
#define IEVENT_TBENDCHANGED					57
#define IEVENT_TBPULLDOWN		      		58
#define IEVENT_TBPULLDOWNEND		      	59
#define IEVENT_TS0MAJORDOUBLECLICK			60
#define IEVENT_TS0MAJORRIGHTDOUBLECLICK		61
#define IEVENT_TS0MAJORRIGHTSINGLECLICK		62
#define IEVENT_TS0MAJORSINGLECLICK			63
#define IEVENT_TS0MINORDOUBLECLICK			64
#define IEVENT_TS0MINORRIGHTDOUBLECLICK		65
#define IEVENT_TS0MINORRIGHTSINGLECLICK		66
#define IEVENT_TS0MINORSINGLECLICK			67
#define IEVENT_TS0SCROLLPASTBEG				68
#define IEVENT_TS0SCROLLPASTEND				69
#define IEVENT_TS0DATETIMEVIEWCHANGED		70
#define IEVENT_TS0SIZECHANGED				71
#define IEVENT_TS1MAJORDOUBLECLICK			72
#define IEVENT_TS1MAJORRIGHTDOUBLECLICK		73
#define IEVENT_TS1MAJORRIGHTSINGLECLICK		74
#define IEVENT_TS1MAJORSINGLECLICK			75
#define IEVENT_TS1MINORDOUBLECLICK			76
#define IEVENT_TS1MINORRIGHTDOUBLECLICK		77
#define IEVENT_TS1MINORRIGHTSINGLECLICK		78
#define IEVENT_TS1MINORSINGLECLICK			79
#define IEVENT_TS1SCROLLPASTBEG				80
#define IEVENT_TS1SCROLLPASTEND				81
#define IEVENT_TS1DATETIMEVIEWCHANGED		82
#define IEVENT_TS1SIZECHANGED				83
                                          

extern "C" {
BOOL FAR PASCAL _loadds GetEventParamString(LPVOID, int, LPSTR);
}


class CScheduleVBX : public CVBControl                                   
{

public:

    enum DisplayMode { DisplayMode_Resource, DisplayMode_YearlyHorz,
    				DisplayMode_YearlyVert, DisplayMode_MonthlyHorz,
    				DisplayMode_MonthlyVert, DisplayMode_WeeklyHorz,
    				DisplayMode_WeeklyVert, DisplayMode_DailyHorz,
    				DisplayMode_DailyVert, DisplayMode_CalendarHorz,
    				DisplayMode_CalendarVert };
    				
    enum Timescale { 	TS_Years, TS_Quarters, TS_Months, TS_Weeks,
						TS_Days, TS_Hours, TS_Minutes };

    enum BorderStyle { Border_None, Border_FixedSingle };

	enum BarTextPosition {	BarTextPosition_None, BarTextPosition_Left,
					BarTextPosition_Right, BarTextPosition_Above,
					BarTextPosition_Below, BarTextPosition_InsideLeft,
					BarTextPosition_InsideCenter, BarTextPosition_InsideRight };

	enum BarTextField {	BarTextField_None, BarTextField_ResourceName,
					BarTextField_ResourceUser1, BarTextField_ResourceUser2,
					BarTextField_ResourceUser3, BarTextField_ResourceUser4,
					BarTextField_TBBeg, BarTextField_TBEnd,
					BarTextField_TBDur, BarTextField_TBGroup,
					BarTextField_TBUser1, BarTextField_TBUser2,
					BarTextField_TBUser3, BarTextField_TBUser4,
					BarTextField_BarName };
										
	enum BarPattern { Pattern_None, Pattern_Horizontal,
					Pattern_Vertical, Pattern_UpwardsHatch,
					Pattern_DownwardsHatch, Pattern_CrossHatch,
					Pattern_45DegreeCrossHatch };

	enum BarAdjustable { Adjustable_Full, Adjustable_BeginOnly,
					Adjustable_MidOnly, Adjustable_EndOnly,
					Adjustable_None };

	enum Symbol {	Symbol_None, Symbol_PentagonUp,
					Symbol_PentagonDown, Symbol_Diamond,
					Symbol_CircledDiamond, Symbol_ArrowheadUp,
					Symbol_ArrowheadDown, Symbol_ArrowheadRight,
					Symbol_ArrowheadLeft, Symbol_CircledArrowheadUp,
					Symbol_CircledArrowheadDown, Symbol_ArrowUp,
					Symbol_ArrowDown, Symbol_CircledArrowUp,
					Symbol_CircledArrowDown, Symbol_ArrowRight,
					Symbol_ArrowLeft, Symbol_CircledArrowRight,
					Symbol_CircledArrowLeft, Symbol_CircledArrowheadRight,
					Symbol_CircledArrowheadLeft, Symbol_PentagonRight,
					Symbol_PentagonLeft };

	enum SymbolType { SymbolType_Solid, SymbolType_Framed };
	
	enum Alignment { Alignment_Left, Alignment_Center, Alignment_Right };

    enum BevelType { BevelType_None, BevelType_Inset, BevelType_Raised };

	enum ResCol { ResCol_None, ResCol_RowNum, ResCol_ResourceNum,
					ResCol_ResourceName, ResCol_BarNum, ResCol_TimeBlocks,
					ResCol_ResourceUser1, ResCol_ResourceUser2,
					ResCol_ResourceUser3, ResCol_ResourceUser4,
					ResCol_LineHeight, ResCol_BackColor,
					ResCol_FontColor, ResCol_FontName,
					ResCol_FontSizePercent, ResCol_FontBold,
					ResCol_FontItalic };

	enum TBCol { TBCol_None, TBCol_RowNum, TBCol_ResourceNum,
					TBCol_TBNum, TBCol_TBBeg, TBCol_TBEnd,
					TBCol_TBDur, TBCol_BarNum, TBCol_GroupNum,
					TBCol_TBUser1, TBCol_TBUser2,
					TBCol_TBUser3, TBCol_TBUser4 };

	enum LegendPosition { LegendPos_Right, LegendPos_Bottom,
					LegendPos_Left, LegendPos_Top };
					
	enum LegendType { LegendType_Resources, LegendType_Bars };
					
    enum FontOrient { FontOrient_Right, FontOrient_Up,
    				FontOrient_Left, FontOrient_Down };
    				
	enum PrintHdrFtr { PrintHdrFtr_AllPages, PrintHdrFtr_1stPage,
					PrintHdrFtr_1stHorz, PrintHdrFtr_1stVert,
					PrintHdrFtr_None };
					    				
          
	CScheduleVBX() : CVBControl() {}
	
	BOOL Create(DWORD dwStyle, const RECT& rect, CWnd* parent, UINT ctlid) 
	{
		return CVBControl::Create("SchedVBX.VBX;SchedVBX;SchedVBX", dwStyle,
									rect, parent, ctlid);
	}

	void InitPropup(int iProp)						
	{   
		HWND hwnd = (HWND)SendMessage(VBM_INITPROPUP, iProp);
		::ShowWindow(hwnd, SW_SHOW);
	}

	// Standard Properties - (Set)
	BOOL SetVisible(BOOL b)   			{ return SetNumProperty(IPROP_VISIBLE, b); }
	BOOL SetCaption(LPCSTR s)   		{ return SetStrProperty(IPROP_CAPTION, s); }
	BOOL SetBorderStyle(int i)    		{ return SetNumProperty(IPROP_BORDERSTYLE, i); }
	BOOL SetBackColor(long l) 			{ return SetNumProperty(IPROP_BACKCOLOR, l); }

	// General Properties - (Set)
	void MasterDialog() 				{ InitPropup(IPROP_MASTERDIALOG); }
	void GeneralDialog() 				{ InitPropup(IPROP_GENERALDIALOG); }
	void About() 						{ InitPropup(IPROP_ABOUT); }
	BOOL SetDisplayMode(int i)    		{ return SetNumProperty(IPROP_DISPLAYMODE, i); }
	BOOL SetBevelHighLightColor(long l) { return SetNumProperty(IPROP_BEVELHIGHLIGHTCOLOR, l); }
	BOOL SetBevelShadowColor(long l) 	{ return SetNumProperty(IPROP_BEVELSHADOWCOLOR, l); }
	BOOL SetBevelWidth(int i)			{ return SetNumProperty(IPROP_BEVELWIDTH, i); }
	BOOL SetGridMajorColor(long l) 	 	{ return SetNumProperty(IPROP_GRIDMAJORCOLOR, l); }
	BOOL SetGridMajorThickness(int i)   { return SetNumProperty(IPROP_GRIDMAJORTHICKNESS, i); }
	BOOL SetProcessTab(BOOL b)   		{ return SetNumProperty(IPROP_PROCESSTAB, b); }
	BOOL SetDoubleClickDivide(int i)	{ return SetNumProperty(IPROP_DOUBLECLICKDIVIDE, i); }
	BOOL SetRedraw(BOOL b)   			{ return SetNumProperty(IPROP_REDRAW, b); }
	BOOL SetScrollBarColor(long l)   	{ return SetNumProperty(IPROP_SCROLLBARCOLOR, l); }
	BOOL SetScrollBarWidth(int i)   	{ return SetNumProperty(IPROP_SCROLLBARWIDTH, i); }
	BOOL SetMonthNumColor(long l)   	{ return SetNumProperty(IPROP_MONTHNUMCOLOR, l); }
	BOOL SetMonthNumSize(int i)   		{ return SetNumProperty(IPROP_MONTHNUMSIZE, i); }
	BOOL SetMonthNonNumColor(long l)   	{ return SetNumProperty(IPROP_MONTHNONNUMCOLOR, l); }
	BOOL SetMonthNonNumSize(int i)   	{ return SetNumProperty(IPROP_MONTHNONNUMSIZE, i); }
	BOOL SetPropertyLoad(LPCSTR s)   	{ return SetStrProperty(IPROP_PROPERTYLOAD, s); }
	BOOL SetPropertySave(LPCSTR s)   	{ return SetStrProperty(IPROP_PROPERTYSAVE, s); }

	// Date/Time Properties	- (Set)
	void DateTimeDialog() 				{ InitPropup(IPROP_DATETIMEDIALOG);	}
    BOOL SetCurrentTimeColor(long l)   	{ return SetNumProperty(IPROP_CURRENTTIMECOLOR, l); }
	BOOL SetCurrentTimeLine(BOOL b)   	{ return SetNumProperty(IPROP_CURRENTTIMELINE, b); }
	BOOL SetDefaultDateTimeFormat(LPCSTR s) { return SetStrProperty(IPROP_DEFAULTDATETIMEFORMAT, s); }
	BOOL SetDefaultDurationFormat(LPCSTR s) { return SetStrProperty(IPROP_DEFAULTDURATIONFORMAT, s); }

	// Timescale Properties - (Set)
	void TimescalesDialog() 			{ InitPropup(IPROP_TSDIALOG); }
    BOOL SetTSThumbWindow(int x, BOOL b){ return SetNumProperty(IPROP_TSTHUMBWINDOW, b, x); }
    BOOL SetTSBackColor(int x, long l)	{ return SetNumProperty(IPROP_TSBACKCOLOR, l, x); }
	BOOL SetTSBevel(int x, int i)		{ return SetNumProperty(IPROP_TSBEVEL, i, x); }
	BOOL SetTSGridColor(int x, long l) 	{ return SetNumProperty(IPROP_TSGRIDCOLOR, l, x); }
	BOOL SetTSGridThickness(int x, int i) { return SetNumProperty(IPROP_TSGRIDTHICKNESS, i, x); }
	BOOL SetTSMajorPercent(int x, int i) { return SetNumProperty(IPROP_TSMAJORPERCENT, i, x); }
	BOOL SetTSNumMinorTicks(int x, int i) { return SetNumProperty(IPROP_TSNUMMINORTICKS, i, x); }
	BOOL SetTSSizeToTick(int x, BOOL b) { return SetNumProperty(IPROP_TSSIZETOTICK, b, x); }
	BOOL SetTSSize(int x, int i) 		{ return SetNumProperty(IPROP_TSSIZE, i, x); }
	BOOL SetTSMajor(int x, int i) 		{ return SetNumProperty(IPROP_TSMAJOR, i, x); }
	BOOL SetTSMajorCount(int x, int i) 	{ return SetNumProperty(IPROP_TSMAJORCOUNT, i, x); }
	BOOL SetTSMajorFontColor(int x, long l) { return SetNumProperty(IPROP_TSMAJORFONTCOLOR, l, x); }
	BOOL SetTSMajorFontName(int x, CString s) { return SetNumProperty(IPROP_TSMAJORFONTNAME, FontNum(s), x); }
	BOOL SetTSMajorFontSizePercent(int x, int i) { return SetNumProperty(IPROP_TSMAJORFONTSIZEPERCENT, i, x); }
	BOOL SetTSMajorFontBold(int x, BOOL b) { return SetNumProperty(IPROP_TSMAJORFONTBOLD, b, x); }
	BOOL SetTSMajorFontItalic(int x, BOOL b) { return SetNumProperty(IPROP_TSMAJORFONTITALIC, b, x); }
	BOOL SetTSMajorFontOrient(int x, int i) { return SetNumProperty(IPROP_TSMAJORFONTORIENT, i, x); }
	BOOL SetTSMajorFormat(int x, int i)	{ return SetNumProperty(IPROP_TSMAJORFORMAT, i, x); }
	BOOL SetTSMajorGrid(int x, BOOL b) 	{ return SetNumProperty(IPROP_TSMAJORGRID, b, x); }
	BOOL SetTSMinor(int x, int i) 		{ return SetNumProperty(IPROP_TSMINOR, i, x); }
	BOOL SetTSMinorCount(int x, int i) 	{ return SetNumProperty(IPROP_TSMINORCOUNT, i, x); }
	BOOL SetTSMinorFontColor(int x, long l) { return SetNumProperty(IPROP_TSMINORFONTCOLOR, l, x); }
	BOOL SetTSMinorFontName(int x, CString s) { return SetNumProperty(IPROP_TSMINORFONTNAME, FontNum(s), x); }
	BOOL SetTSMinorFontSizePercent(int x, int i) { return SetNumProperty(IPROP_TSMINORFONTSIZEPERCENT, i, x); }
	BOOL SetTSMinorFontBold(int x, BOOL b) { return SetNumProperty(IPROP_TSMINORFONTBOLD, b, x); }
	BOOL SetTSMinorFontItalic(int x, BOOL b) { return SetNumProperty(IPROP_TSMINORFONTITALIC, b, x); }
	BOOL SetTSMinorFontOrient(int x, int i) { return SetNumProperty(IPROP_TSMINORFONTORIENT, i, x); }
	BOOL SetTSMinorFormat(int x, int i)	{ return SetNumProperty(IPROP_TSMINORFORMAT, i, x); }
	BOOL SetTSMinorGrid(int x, BOOL b) 	{ return SetNumProperty(IPROP_TSMINORGRID, b, x); }
	BOOL SetTSRulerLarge(int x, int i)	{ return SetNumProperty(IPROP_TSRULERLARGE, i, x); }
	BOOL SetTSRulerSmall(int x, int i)	{ return SetNumProperty(IPROP_TSRULERSMALL, i, x); }
	BOOL SetTSRulerColor(int x, long l)	{ return SetNumProperty(IPROP_TSRULERCOLOR, l, x); }
	BOOL SetTSDateTimeBeg(int x, LPCSTR s) { return SetStrProperty(IPROP_TSDATETIMEBEG, s, x); }
	BOOL SetTSDateTimeEnd(int x, LPCSTR s) { return SetStrProperty(IPROP_TSDATETIMEEND, s, x); }
	BOOL SetTSDateTimeView(int x, LPCSTR s) { return SetStrProperty(IPROP_TSDATETIMEVIEW, s, x); }

	// Bar Properties - (Set)
	void BarsDialog() 					{ InitPropup(IPROP_BARSDIALOG); }
	BOOL SetBarsMax(int i)	 			{ return SetNumProperty(IPROP_BARSMAX, i); }
	BOOL SetBarMoveTextFormat(LPCSTR s) { return SetStrProperty(IPROP_BARMOVETEXTFORMAT, s); }
	BOOL SetBarName(int x, LPCSTR s) 	{ return SetStrProperty(IPROP_BARNAME, s, x); }
	BOOL SetBarSize(int x, int i)	 	{ return SetNumProperty(IPROP_BARSIZE, i, x); }
	BOOL SetBarOffset(int x, int i)	 	{ return SetNumProperty(IPROP_BAROFFSET, i, x); }
	BOOL SetBarColor(int x, long l)	 	{ return SetNumProperty(IPROP_BARCOLOR, l, x); }
	BOOL SetBarPattern(int x, int i)	{ return SetNumProperty(IPROP_BARPATTERN, i, x); }
	BOOL SetBarAdjustable(int x, int i) { return SetNumProperty(IPROP_BARADJUSTABLE, i, x); }
	BOOL SetBarTextPosition(int x, int i) { return SetNumProperty(IPROP_BARTEXTPOSITION, i, x); }
	BOOL SetBarTextField(int x, int i)	{ return SetNumProperty(IPROP_BARTEXTFIELD, i, x); }
	BOOL SetBarTextFormat(int x, LPCSTR s){ return SetStrProperty(IPROP_BARTEXTFORMAT, s, x); }
	BOOL SetBarTextClip(int x, BOOL b)	{ return SetNumProperty(IPROP_BARTEXTCLIP, b, x); }
	BOOL SetBarFontColor(int x, long l) { return SetNumProperty(IPROP_BARFONTCOLOR, l, x); }
	BOOL SetBarFontName(int x, CString s) { return SetNumProperty(IPROP_BARFONTNAME, FontNum(s), x); }
	BOOL SetBarFontSizePercent(int x, int i) { return SetNumProperty(IPROP_BARFONTSIZEPERCENT, i, x); }
	BOOL SetBarFontBold(int x, BOOL b) { return SetNumProperty(IPROP_BARFONTBOLD, b, x); }
	BOOL SetBarFontItalic(int x, BOOL b) { return SetNumProperty(IPROP_BARFONTITALIC, b, x); }
	BOOL SetBarBegSymbol(int x, int i)	{ return SetNumProperty(IPROP_BARBEGSYMBOL, i, x); }
	BOOL SetBarBegType(int x, int i)	{ return SetNumProperty(IPROP_BARBEGTYPE, i, x); }
	BOOL SetBarBegColor(int x, long l)	{ return SetNumProperty(IPROP_BARBEGCOLOR, l, x); }
	BOOL SetBarBegSize(int x, int i)	{ return SetNumProperty(IPROP_BARBEGSIZE, i, x); }
	BOOL SetBarBegOffset(int x, int i)	{ return SetNumProperty(IPROP_BARBEGOFFSET, i, x); }
	BOOL SetBarEndSymbol(int x, int i)	{ return SetNumProperty(IPROP_BARENDSYMBOL, i, x); }
	BOOL SetBarEndType(int x, int i)	{ return SetNumProperty(IPROP_BARENDTYPE, i, x); }
	BOOL SetBarEndColor(int x, long l)	{ return SetNumProperty(IPROP_BARENDCOLOR, l, x); }
	BOOL SetBarEndSize(int x, int i)	{ return SetNumProperty(IPROP_BARENDSIZE, i, x); }
	BOOL SetBarEndOffset(int x, int i)	{ return SetNumProperty(IPROP_BARENDOFFSET, i, x); }

    // Resource Header Properties - (Set)
   	void ResHdrDialog() 				{ InitPropup(IPROP_RESHDRDIALOG); }
	BOOL SetResHdrHeight(int i) 		{ return SetNumProperty(IPROP_RESHDRHEIGHT, i); }
	BOOL SetResHdrBackColor(long l) 	{ return SetNumProperty(IPROP_RESHDRBACKCOLOR, l); }
	BOOL SetResHdrBevel(int i) 		{ return SetNumProperty(IPROP_RESHDRBEVEL, i); }
	BOOL SetResHdrFontColor(long l) 	{ return SetNumProperty(IPROP_RESHDRFONTCOLOR, l); }
	BOOL SetResHdrFontName(CString s)	{ return SetNumProperty(IPROP_RESHDRFONTNAME, FontNum(s)); }
	BOOL SetResHdrFontSizePercent(int i) { return SetNumProperty(IPROP_RESHDRFONTSIZEPERCENT, i); }
 	BOOL SetResHdrFontBold(BOOL b)		{ return SetNumProperty(IPROP_RESHDRFONTBOLD, b); }
	BOOL SetResHdrFontItalic(BOOL b) 	{ return SetNumProperty(IPROP_RESHDRFONTITALIC, b); }
	BOOL SetResHdrGridColor(long l) 	{ return SetNumProperty(IPROP_RESHDRGRIDCOLOR, l); }
	BOOL SetResHdrGridThickness(int i)	{ return SetNumProperty(IPROP_RESHDRGRIDTHICKNESS, i); }
	BOOL SetResHdrResize(BOOL b)		{ return SetNumProperty(IPROP_RESHDRRESIZE, b); }

	// Resouce Column Properties - (Set)
	void ResColDialog() 				{ InitPropup(IPROP_RESCOLDIALOG); }
	BOOL SetResColMax(int i) 			{ return SetNumProperty(IPROP_RESCOLMAX, i); }
	BOOL SetResColField(int x, int i) 	{ return SetNumProperty(IPROP_RESCOLFIELD, i, x); }
	BOOL SetResColFormat(int x, LPCSTR s) { return SetStrProperty(IPROP_RESCOLFORMAT, s, x); }
	BOOL SetResColLabel(int x, LPCSTR s) { return SetStrProperty(IPROP_RESCOLLABEL, s, x); }
	BOOL SetResColWidth(int x, int i)	{ return SetNumProperty(IPROP_RESCOLWIDTH, i, x); }
	BOOL SetResColAlignment(int x, int i) { return SetNumProperty(IPROP_RESCOLALIGNMENT, i, x); }
	BOOL SetResColVisible(int x, BOOL b) { return SetNumProperty(IPROP_RESCOLVISIBLE, b, x); }
	BOOL SetResColFrozen(int x, BOOL b)	{ return SetNumProperty(IPROP_RESCOLFROZEN, b, x); }
	BOOL SetResColEditable(int x, BOOL b) { return SetNumProperty(IPROP_RESCOLEDITABLE, b, x); }
	BOOL SetResColResizable(int x, BOOL b) { return SetNumProperty(IPROP_RESCOLRESIZABLE, b, x); }

	// Resource List Properties - (Set)
	void ResDialog() 					{ InitPropup(IPROP_RESDIALOG); }
	BOOL SetResMax(int i) 				{ return SetNumProperty(IPROP_RESMAX, i); }
	BOOL SetResView(int i) 				{ return SetNumProperty(IPROP_RESVIEW, i); }
	BOOL SetResWidth(int i) 			{ return SetNumProperty(IPROP_RESWIDTH, i); }
	BOOL SetResUnusedBackColor(long l)	{ return SetNumProperty(IPROP_RESUNUSEDBACKCOLOR, l); }
	BOOL SetResBevel(int i) 			{ return SetNumProperty(IPROP_RESBEVEL, i); }
	BOOL SetResGridColor(long l) 		{ return SetNumProperty(IPROP_RESGRIDCOLOR, l); }
	BOOL SetResGridThickness(int i)		{ return SetNumProperty(IPROP_RESGRIDTHICKNESS, i); }
	BOOL SetResWidthResize(BOOL b)		{ return SetNumProperty(IPROP_RESWIDTHRESIZE, b); }
	BOOL SetResLineResize(BOOL b)		{ return SetNumProperty(IPROP_RESLINERESIZE, b); }
	BOOL SetResCurrentCol(int i)		{ return SetNumProperty(IPROP_RESCURRENTCOL, i); }
	BOOL SetResCurrentRow(int i)		{ return SetNumProperty(IPROP_RESCURRENTROW, i); }

	// Resource Array Properties - (Set)
	BOOL SetResName(int x, LPCSTR s)	{ return SetStrProperty(IPROP_RESNAME, s, x); }
	BOOL SetResBarDefault(int x, int i)	{ return SetNumProperty(IPROP_RESBARDEFAULT, i, x); }
	BOOL SetResUser1(int x, LPCSTR s)	{ return SetStrProperty(IPROP_RESUSER1, s, x); }
	BOOL SetResUser2(int x, LPCSTR s)	{ return SetStrProperty(IPROP_RESUSER2, s, x); }
	BOOL SetResUser3(int x, LPCSTR s)	{ return SetStrProperty(IPROP_RESUSER3, s, x); }
	BOOL SetResUser4(int x, LPCSTR s)	{ return SetStrProperty(IPROP_RESUSER4, s, x); }
	BOOL SetResLineHeight(int x, int i)	{ return SetNumProperty(IPROP_RESLINEHEIGHT, i, x); }
	BOOL SetResBackColor(int x, long l) { return SetNumProperty(IPROP_RESBACKCOLOR, l, x); }
	BOOL SetResFontColor(int x, long l) { return SetNumProperty(IPROP_RESFONTCOLOR, l, x); }
	BOOL SetResFontName(int x, CString s) { return SetNumProperty(IPROP_RESFONTNAME, FontNum(s), x); }
	BOOL SetResFontSizePercent(int x, int i) { return SetNumProperty(IPROP_RESFONTSIZEPERCENT, i, x); }
 	BOOL SetResFontBold(int x, BOOL b)	{ return SetNumProperty(IPROP_RESFONTBOLD, b, x); }
	BOOL SetResFontItalic(int x, BOOL b) { return SetNumProperty(IPROP_RESFONTITALIC, b, x); }

	// Resource Method Properties - (Set)    
	BOOL SetResClear()					{ return SetNumProperty(IPROP_RESCLEAR, 0); }
	BOOL SetResDelete(int x, int i)		{ return SetNumProperty(IPROP_RESDELETE, i, x); }
	BOOL SetResInsert(int x, int i)		{ return SetNumProperty(IPROP_RESINSERT, i, x); }
	BOOL SetResSort(int i)				{ return SetNumProperty(IPROP_RESSORT, i); }
	BOOL SetResLoad(LPCSTR s)			{ return SetStrProperty(IPROP_RESLOAD, s); }
	BOOL SetResSave(LPCSTR s)			{ return SetStrProperty(IPROP_RESSAVE, s); }

	// TimeBlock Header Properties - (Set)
   	void TBHdrDialog() 					{ InitPropup(IPROP_TBHDRDIALOG); }
	BOOL SetTBHdrBackColor(long l) 		{ return SetNumProperty(IPROP_TBHDRBACKCOLOR, l); }
	BOOL SetTBHdrBevel(int i) 			{ return SetNumProperty(IPROP_TBHDRBEVEL, i); }
	BOOL SetTBHdrGridColor(long l) 		{ return SetNumProperty(IPROP_TBHDRGRIDCOLOR, l); }
	BOOL SetTBHdrHeight(int i)			{ return SetNumProperty(IPROP_TBHDRHEIGHT, i); }
    
	// TimeBlock Column Properties - (Set)
	void TBColDialog() 					{ InitPropup(IPROP_TBCOLDIALOG); }
	BOOL SetTBColMax(int i) 			{ return SetNumProperty(IPROP_TBCOLMAX, i); }
	BOOL SetTBColField(int x, int i) 	{ return SetNumProperty(IPROP_TBCOLFIELD, i, x); }
	BOOL SetTBColFormat(int x, LPCSTR s) { return SetStrProperty(IPROP_TBCOLFORMAT, s, x); }
	BOOL SetTBColLabel(int x, LPCSTR s) { return SetStrProperty(IPROP_TBCOLLABEL, s, x); }
	BOOL SetTBColWidth(int x, int i)	{ return SetNumProperty(IPROP_TBCOLWIDTH, i, x); }
	BOOL SetTBColAlignment(int x, int i) { return SetNumProperty(IPROP_TBCOLALIGNMENT, i, x); }
	BOOL SetTBColVisible(int x, BOOL b) { return SetNumProperty(IPROP_TBCOLVISIBLE, b, x); }
	BOOL SetTBColFrozen(int x, BOOL b)	{ return SetNumProperty(IPROP_TBCOLFROZEN, b, x); }
	BOOL SetTBColEditable(int x, BOOL b) { return SetNumProperty(IPROP_TBCOLEDITABLE, b, x); }
	BOOL SetTBColResizable(int x, BOOL b) { return SetNumProperty(IPROP_TBCOLRESIZABLE, b, x); }
    
	// TimeBlock List Properties - (Set)
	void TBDialog() 					{ InitPropup(IPROP_TBDIALOG); }
	BOOL SetTBMax(int i) 				{ return SetNumProperty(IPROP_TBMAX, i); }
	BOOL SetTBHeight(int i) 			{ return SetNumProperty(IPROP_TBHEIGHT, i); }
	BOOL SetTBLineHeight(int i) 		{ return SetNumProperty(IPROP_TBLINEHEIGHT, i); }
	BOOL SetTBView(int i) 				{ return SetNumProperty(IPROP_TBVIEW, i); }
	BOOL SetTBWidth(int i) 				{ return SetNumProperty(IPROP_TBWIDTH, i); }
	BOOL SetTBBackColor(long l)			{ return SetNumProperty(IPROP_TBBACKCOLOR, l); }
	BOOL SetTBBevel(int i) 				{ return SetNumProperty(IPROP_TBBEVEL, i); }
	BOOL SetTBGridColor(long l) 		{ return SetNumProperty(IPROP_TBGRIDCOLOR, l); }
	BOOL SetTBFontColor(long l) 		{ return SetNumProperty(IPROP_TBFONTCOLOR, l); }
	BOOL SetTBFontName(CString s) 		{ return SetNumProperty(IPROP_TBFONTNAME, FontNum(s)); }
	BOOL SetTBFontSizePercent(int i) 	{ return SetNumProperty(IPROP_TBFONTSIZEPERCENT, i); }
 	BOOL SetTBFontBold(BOOL b)			{ return SetNumProperty(IPROP_TBFONTBOLD, b); }
	BOOL SetTBFontItalic(BOOL b) 		{ return SetNumProperty(IPROP_TBFONTITALIC, b); }
    
	// TimeBlock Array Properties - (Set)
	BOOL SetTBResource(int x, int i)	{ return SetNumProperty(IPROP_TBRESOURCE, i, x); }
	BOOL SetTBBeg(int x, LPCSTR s)		{ return SetStrProperty(IPROP_TBBEG, s, x); }
	BOOL SetTBEnd(int x, LPCSTR s)		{ return SetStrProperty(IPROP_TBEND, s, x); }
	BOOL SetTBDur(int x, LPCSTR s)		{ return SetStrProperty(IPROP_TBDUR, s, x); }
	BOOL SetTBBar(int x, int i)			{ return SetNumProperty(IPROP_TBBAR, i, x); }
	BOOL SetTBGroup(int x, int i)		{ return SetNumProperty(IPROP_TBGROUP, i, x); }
	BOOL SetTBUser1(int x, LPCSTR s)	{ return SetStrProperty(IPROP_TBUSER1, s, x); }
	BOOL SetTBUser2(int x, LPCSTR s)	{ return SetStrProperty(IPROP_TBUSER2, s, x); }
	BOOL SetTBUser3(int x, LPCSTR s)	{ return SetStrProperty(IPROP_TBUSER3, s, x); }
	BOOL SetTBUser4(int x, LPCSTR s)	{ return SetStrProperty(IPROP_TBUSER4, s, x); }
    
	// TimeBlock Method Properties - (Set)
	BOOL SetTBClear()					{ return SetNumProperty(IPROP_TBCLEAR, 0); }
	BOOL SetTBClearRes(int i)			{ return SetNumProperty(IPROP_TBCLEARRES, i); }
	BOOL SetTBDelete(int x, int i)		{ return SetNumProperty(IPROP_TBDELETE, i, x); }
	BOOL SetTBLoad(LPCSTR s)			{ return SetStrProperty(IPROP_TBLOAD, s); }
	BOOL SetTBSave(LPCSTR s)			{ return SetStrProperty(IPROP_TBSAVE, s); }
    
	// Schedule Bar Area Properties - (Set)
	void SchedDialog() 					{ InitPropup(IPROP_SCHEDDIALOG); }
	BOOL SetSchedBackColor(long l) 		{ return SetNumProperty(IPROP_SCHEDBACKCOLOR, l); }
	BOOL SetSchedBevel(int i) 			{ return SetNumProperty(IPROP_SCHEDBEVEL, i); }
	BOOL SetSchedGridColor(long l) 		{ return SetNumProperty(IPROP_SCHEDGRIDCOLOR, l); }
	BOOL SetSchedGridThickness(int i) 	{ return SetNumProperty(IPROP_SCHEDGRIDTHICKNESS, i); }

	// Legend Properties - (Set)
	void LegendDialog() 				{ InitPropup(IPROP_LEGENDDIALOG); }
	BOOL SetLegendTitle(LPCSTR s)		{ return SetStrProperty(IPROP_LEGENDTITLE, s); }
	BOOL SetLegendPosition(int i) 		{ return SetNumProperty(IPROP_LEGENDPOSITION, i); }
	BOOL SetLegendType(int i) 			{ return SetNumProperty(IPROP_LEGENDTYPE, i); }
	BOOL SetLegendSize(int i) 			{ return SetNumProperty(IPROP_LEGENDSIZE, i); }
	BOOL SetLegendLineHeight(int i) 	{ return SetNumProperty(IPROP_LEGENDLINEHEIGHT, i); }
	BOOL SetLegendBackColor(long l) 	{ return SetNumProperty(IPROP_LEGENDBACKCOLOR, l); }
	BOOL SetLegendBevel(int i) 			{ return SetNumProperty(IPROP_LEGENDBEVEL, i); }
	BOOL SetLegendView(int i) 			{ return SetNumProperty(IPROP_LEGENDVIEW, i); }
	BOOL SetLegendSelection(int i) 		{ return SetNumProperty(IPROP_LEGENDSELECTION, i); }
	BOOL SetLegendResize(BOOL b) 		{ return SetNumProperty(IPROP_LEGENDRESIZE, b); }
    
	// Print Properties - (Set)
	BOOL SetPrintLeftMargin(float f)	{ return SetFloatProperty(IPROP_PRINTLEFTMARGIN, f); }
	BOOL SetPrintTopMargin(float f)		{ return SetFloatProperty(IPROP_PRINTTOPMARGIN, f); }
	BOOL SetPrintRightMargin(float f)	{ return SetFloatProperty(IPROP_PRINTRIGHTMARGIN, f); }
	BOOL SetPrintBottomMargin(float f)	{ return SetFloatProperty(IPROP_PRINTBOTTOMMARGIN, f); }
	BOOL SetPrintWidth(float f)			{ return SetFloatProperty(IPROP_PRINTWIDTH, f); }
	BOOL SetPrintHeight(float f)		{ return SetFloatProperty(IPROP_PRINTHEIGHT, f); }
	BOOL SetPrintHeader(int i)			{ return SetNumProperty(IPROP_PRINTHEADER, i); }
	BOOL SetPrintHeaderHeight(float f)	{ return SetFloatProperty(IPROP_PRINTHEADERHEIGHT, f); }
	BOOL SetPrintHeaderText(LPCSTR s)	{ return SetStrProperty(IPROP_PRINTHEADERTEXT, s); }
	BOOL SetPrintHeaderTextHeight(float f) { return SetFloatProperty(IPROP_PRINTHEADERTEXTHEIGHT, f); }
	BOOL SetPrintFooter(int i)			{ return SetNumProperty(IPROP_PRINTFOOTER, i); }
	BOOL SetPrintFooterHeight(float f)	{ return SetFloatProperty(IPROP_PRINTFOOTERHEIGHT, f); }
	BOOL SetPrintFooterText(LPCSTR s)	{ return SetStrProperty(IPROP_PRINTFOOTERTEXT, s); }
	BOOL SetPrintFooterTextHeight(float f) { return SetFloatProperty(IPROP_PRINTFOOTERTEXTHEIGHT, f); }
	BOOL SetPrintShowDialog(BOOL b) 	{ return SetNumProperty(IPROP_PRINTSHOWDIALOG, b); }
	BOOL SetPrintScreen()				{ return SetNumProperty(IPROP_PRINTSCREEN, 0); }
	BOOL SetPrintChart()				{ return SetNumProperty(IPROP_PRINTCHART, 0); }


	// Standard Properties - (Get)
	BOOL GetVisible()   				{ return (BOOL)GetNumProperty(IPROP_VISIBLE); }
	CString GetCaption()   				{ return GetStrProperty(IPROP_CAPTION); }
	int	 GetBorderStyle()    			{ return (int)GetNumProperty(IPROP_BORDERSTYLE); }
	long GetBackColor() 				{ return GetNumProperty(IPROP_BACKCOLOR); }

	// General Properties - (Get)
	int  GetDisplayMode()    			{ return (int)GetNumProperty(IPROP_DISPLAYMODE); }
	long GetBevelHighLightColor() 		{ return GetNumProperty(IPROP_BEVELHIGHLIGHTCOLOR); }
	long GetBevelShadowColor() 			{ return GetNumProperty(IPROP_BEVELSHADOWCOLOR); }
	int  GetBevelWidth()				{ return (int)GetNumProperty(IPROP_BEVELWIDTH); }
	long GetGridMajorColor() 	 		{ return GetNumProperty(IPROP_GRIDMAJORCOLOR); }
	int  GetGridMajorThickness()   		{ return (int)GetNumProperty(IPROP_GRIDMAJORTHICKNESS); }
	HINSTANCE GetHInstance()			{ return (HINSTANCE)GetNumProperty(IPROP_HINSTANCE); }
	BOOL GetProcessTab()   				{ return (BOOL)GetNumProperty(IPROP_PROCESSTAB); }
	int  GetDoubleClickDivide()			{ return (int)GetNumProperty(IPROP_DOUBLECLICKDIVIDE); }
	BOOL GetRedraw()   					{ return (BOOL)GetNumProperty(IPROP_REDRAW); }
	long GetScrollBarColor()   			{ return GetNumProperty(IPROP_SCROLLBARCOLOR); }
	int  GetScrollBarWidth()   			{ return (int)GetNumProperty(IPROP_SCROLLBARWIDTH); }
	long GetMonthNumColor()   			{ return GetNumProperty(IPROP_MONTHNUMCOLOR); }
	int  GetMonthNumSize()   			{ return (int)GetNumProperty(IPROP_MONTHNUMSIZE); }
	long GetMonthNonNumColor()   		{ return GetNumProperty(IPROP_MONTHNONNUMCOLOR); }
	int  GetMonthNonNumSize()   		{ return (int)GetNumProperty(IPROP_MONTHNONNUMSIZE); }

	// Date/Time Properties	- (Get)
    long GetCurrentTimeColor()   		{ return GetNumProperty(IPROP_CURRENTTIMECOLOR); }
	BOOL GetCurrentTimeLine()   		{ return (BOOL)GetNumProperty(IPROP_CURRENTTIMELINE); }
	CString GetDefaultDateTimeFormat()	{ return GetStrProperty(IPROP_DEFAULTDATETIMEFORMAT); }
	CString GetDefaultDurationFormat()	{ return GetStrProperty(IPROP_DEFAULTDURATIONFORMAT); }

	// Timescale Properties - (Get)
    BOOL GetTSThumbWindow(int x)		{ return (BOOL)GetNumProperty(IPROP_TSTHUMBWINDOW, x); }
    long GetTSBackColor(int x)			{ return GetNumProperty(IPROP_TSBACKCOLOR, x); }
	int  GetTSBevel(int x)				{ return (int)GetNumProperty(IPROP_TSBEVEL, x); }
	long GetTSGridColor(int x) 			{ return GetNumProperty(IPROP_TSGRIDCOLOR, x); }
	int  GetTSGridThickness(int x) 		{ return (int)GetNumProperty(IPROP_TSGRIDTHICKNESS, x); }
	int  GetTSMajorPercent(int x) 		{ return (int)GetNumProperty(IPROP_TSMAJORPERCENT, x); }
	int  GetTSNumMinorTicks(int x) 		{ return (int)GetNumProperty(IPROP_TSNUMMINORTICKS, x); }
	BOOL GetTSSizeToTick(int x) 		{ return (int)GetNumProperty(IPROP_TSSIZETOTICK, x); }
	int  GetTSSize(int x) 				{ return (int)GetNumProperty(IPROP_TSSIZE, x); }
	int  GetTSMajor(int x) 				{ return (int)GetNumProperty(IPROP_TSMAJOR, x); }
	int  GetTSMajorCount(int x) 		{ return (int)GetNumProperty(IPROP_TSMAJORCOUNT, x); }
	long GetTSMajorFontColor(int x) 	{ return GetNumProperty(IPROP_TSMAJORFONTCOLOR, x); }
	CString GetTSMajorFontName(int x) 	{ char szBuf[81]; FontName((int)GetNumProperty(IPROP_TSMAJORFONTNAME, x), szBuf); return szBuf; }
	int  GetTSMajorFontSizePercent(int x) { return (int)GetNumProperty(IPROP_TSMAJORFONTSIZEPERCENT, x); }
	BOOL GetTSMajorFontBold(int x) 		{ return (BOOL)GetNumProperty(IPROP_TSMAJORFONTBOLD, x); }
	BOOL GetTSMajorFontItalic(int x) 	{ return (BOOL)GetNumProperty(IPROP_TSMAJORFONTITALIC, x); }
	int  GetTSMajorFontOrient(int x) 	{ return (int)GetNumProperty(IPROP_TSMAJORFONTORIENT, x); }
	int  GetTSMajorFormat(int x)		{ return (int)GetNumProperty(IPROP_TSMAJORFORMAT, x); }
	BOOL GetTSMajorGrid(int x) 			{ return (BOOL)GetNumProperty(IPROP_TSMAJORGRID, x); }
	int  GetTSMinor(int x) 				{ return (int)GetNumProperty(IPROP_TSMINOR, x); }
	int  GetTSMinorCount(int x) 		{ return (int)GetNumProperty(IPROP_TSMINORCOUNT, x); }
	long GetTSMinorFontColor(int x) 	{ return GetNumProperty(IPROP_TSMINORFONTCOLOR, x); }
	CString GetTSMinorFontName(int x) 	{ char szBuf[81]; FontName((int)GetNumProperty(IPROP_TSMINORFONTNAME, x), szBuf); return szBuf; }
	int  GetTSMinorFontSizePercent(int x) { return (int)GetNumProperty(IPROP_TSMINORFONTSIZEPERCENT, x); }
	BOOL GetTSMinorFontBold(int x) 		{ return (BOOL)GetNumProperty(IPROP_TSMINORFONTBOLD, x); }
	BOOL GetTSMinorFontItalic(int x) 	{ return (BOOL)GetNumProperty(IPROP_TSMINORFONTITALIC, x); }
	int  GetTSMinorFontOrient(int x) 	{ return (int)GetNumProperty(IPROP_TSMINORFONTORIENT, x); }
	int  GetTSMinorFormat(int x)		{ return (int)GetNumProperty(IPROP_TSMINORFORMAT, x); }
	BOOL GetTSMinorGrid(int x) 			{ return (BOOL)GetNumProperty(IPROP_TSMINORGRID, x); }
	int  GetTSRulerLarge(int x)			{ return (int)GetNumProperty(IPROP_TSRULERLARGE, x); }
	int  GetTSRulerSmall(int x)			{ return (int)GetNumProperty(IPROP_TSRULERSMALL, x); }
	long GetTSRulerColor(int x)			{ return GetNumProperty(IPROP_TSRULERCOLOR, x); }
	CString GetTSDateTimeBeg(int x) 	{ return GetStrProperty(IPROP_TSDATETIMEBEG, x); }
	CString GetTSDateTimeEnd(int x) 	{ return GetStrProperty(IPROP_TSDATETIMEEND, x); }
	CString GetTSDateTimeView(int x) 	{ return GetStrProperty(IPROP_TSDATETIMEVIEW, x); }

	// Bar Properties - (Get)
	int  GetBarsMax()	 				{ return (int)GetNumProperty(IPROP_BARSMAX); }
	CString GetBarMoveTextFormat() 		{ return GetStrProperty(IPROP_BARMOVETEXTFORMAT); }
	CString GetBarName(int x) 			{ return GetStrProperty(IPROP_BARNAME, x); }
	int  GetBarSize(int x)	 			{ return (int)GetNumProperty(IPROP_BARSIZE, x); }
	int  GetBarOffset(int x)	 		{ return (int)GetNumProperty(IPROP_BAROFFSET, x); }
	long GetBarColor(int x)	 			{ return GetNumProperty(IPROP_BARCOLOR, x); }
	int  GetBarPattern(int x)			{ return (int)GetNumProperty(IPROP_BARPATTERN, x); }
	int  GetBarAdjustable(int x) 		{ return (int)GetNumProperty(IPROP_BARADJUSTABLE, x); }
	int  GetBarTextPosition(int x) 		{ return (int)GetNumProperty(IPROP_BARTEXTPOSITION, x); }
	int  GetBarTextField(int x)			{ return (int)GetNumProperty(IPROP_BARTEXTFIELD, x); }
	CString GetBarTextFormat(int x)		{ return GetStrProperty(IPROP_BARTEXTFORMAT, x); }
	BOOL GetBarTextClip(int x)			{ return (BOOL)GetNumProperty(IPROP_BARTEXTCLIP, x); }
	long GetBarFontColor(int x) 		{ return GetNumProperty(IPROP_BARFONTCOLOR, x); }
	CString GetBarFontName(int x) 		{ char szBuf[81]; FontName((int)GetNumProperty(IPROP_BARFONTNAME, x), szBuf); return szBuf; }
	int  GetBarFontSizePercent(int x) 	{ return (int)GetNumProperty(IPROP_BARFONTSIZEPERCENT, x); }
	BOOL GetBarFontBold(int x) 			{ return (BOOL)GetNumProperty(IPROP_BARFONTBOLD, x); }
	BOOL GetBarFontItalic(int x) 		{ return (BOOL)GetNumProperty(IPROP_BARFONTITALIC, x); }
	int  GetBarBegSymbol(int x)			{ return (int)GetNumProperty(IPROP_BARBEGSYMBOL, x); }
	int  GetBarBegType(int x)			{ return (int)GetNumProperty(IPROP_BARBEGTYPE, x); }
	long GetBarBegColor(int x)			{ return GetNumProperty(IPROP_BARBEGCOLOR, x); }
	int  GetBarBegSize(int x)			{ return (int)GetNumProperty(IPROP_BARBEGSIZE, x); }
	int  GetBarBegOffset(int x)			{ return (int)GetNumProperty(IPROP_BARBEGOFFSET, x); }
	int  GetBarEndSymbol(int x)			{ return (int)GetNumProperty(IPROP_BARENDSYMBOL, x); }
	int  GetBarEndType(int x)			{ return (int)GetNumProperty(IPROP_BARENDTYPE, x); }
	long GetBarEndColor(int x)			{ return GetNumProperty(IPROP_BARENDCOLOR, x); }
	int  GetBarEndSize(int x)			{ return (int)GetNumProperty(IPROP_BARENDSIZE, x); }
	int  GetBarEndOffset(int x)			{ return (int)GetNumProperty(IPROP_BARENDOFFSET, x); }

    // Resource Header Properties - (Get)
	int  GetResHdrHeight() 				{ return (int)GetNumProperty(IPROP_RESHDRHEIGHT); }
	long GetResHdrBackColor() 			{ return GetNumProperty(IPROP_RESHDRBACKCOLOR); }
	int  GetResHdrBevel() 				{ return (int)GetNumProperty(IPROP_RESHDRBEVEL); }
	long GetResHdrFontColor() 			{ return GetNumProperty(IPROP_RESHDRFONTCOLOR); }
	CString GetResHdrFontName()			{ char szBuf[81]; FontName((int)GetNumProperty(IPROP_RESHDRFONTNAME), szBuf); return szBuf; }
	int  GetResHdrFontSizePercent() 	{ return (int)GetNumProperty(IPROP_RESHDRFONTSIZEPERCENT); }
 	BOOL GetResHdrFontBold()			{ return (BOOL)GetNumProperty(IPROP_RESHDRFONTBOLD); }
	BOOL GetResHdrFontItalic() 			{ return (BOOL)GetNumProperty(IPROP_RESHDRFONTITALIC); }
	long GetResHdrGridColor() 			{ return GetNumProperty(IPROP_RESHDRGRIDCOLOR); }
	int  GetResHdrGridThickness()		{ return (int)GetNumProperty(IPROP_RESHDRGRIDTHICKNESS); }
	BOOL GetResHdrResize()				{ return (BOOL)GetNumProperty(IPROP_RESHDRRESIZE); }

	// Resouce Column Properties - (Get)
	int  GetResColMax() 				{ return (int)GetNumProperty(IPROP_RESCOLMAX); }
	int  GetResColField(int x) 			{ return (int)GetNumProperty(IPROP_RESCOLFIELD, x); }
	CString GetResColFormat(int x) 		{ return GetStrProperty(IPROP_RESCOLFORMAT, x); }
	CString GetResColLabel(int x) 		{ return GetStrProperty(IPROP_RESCOLLABEL, x); }
	int  GetResColWidth(int x)			{ return (int)GetNumProperty(IPROP_RESCOLWIDTH, x); }
	int  GetResColAlignment(int x) 		{ return (int)GetNumProperty(IPROP_RESCOLALIGNMENT, x); }
	BOOL GetResColVisible(int x) 		{ return (BOOL)GetNumProperty(IPROP_RESCOLVISIBLE, x); }
	BOOL GetResColFrozen(int x)			{ return (BOOL)GetNumProperty(IPROP_RESCOLFROZEN, x); }
	BOOL GetResColEditable(int x) 		{ return (BOOL)GetNumProperty(IPROP_RESCOLEDITABLE, x); }
	BOOL GetResColResizable(int x) 		{ return (BOOL)GetNumProperty(IPROP_RESCOLRESIZABLE, x); }

	// Resource List Properties - (Get)
	int  GetResMax() 					{ return (int)GetNumProperty(IPROP_RESMAX); }
	int  GetResView() 					{ return (int)GetNumProperty(IPROP_RESVIEW); }
	int  GetResWidth() 					{ return (int)GetNumProperty(IPROP_RESWIDTH); }
	long GetResUnusedBackColor()		{ return GetNumProperty(IPROP_RESUNUSEDBACKCOLOR); }
	int  GetResBevel() 					{ return (int)GetNumProperty(IPROP_RESBEVEL); }
	long GetResGridColor() 				{ return GetNumProperty(IPROP_RESGRIDCOLOR); }
	int  GetResGridThickness()			{ return (int)GetNumProperty(IPROP_RESGRIDTHICKNESS); }
	BOOL GetResWidthResize()			{ return (BOOL)GetNumProperty(IPROP_RESWIDTHRESIZE); }
	BOOL GetResLineResize()				{ return (BOOL)GetNumProperty(IPROP_RESLINERESIZE); }
	int  GetResCurrentCol()				{ return (int)GetNumProperty(IPROP_RESCURRENTCOL); }
	int  GetResCurrentRow()				{ return (int)GetNumProperty(IPROP_RESCURRENTROW); }

	// Resource Array Properties - (Get)
	CString GetResName(int x)			{ return GetStrProperty(IPROP_RESNAME, x); }
	int  GetResBarDefault(int x)		{ return (int)GetNumProperty(IPROP_RESBARDEFAULT, x); }
	CString GetResUser1(int x)			{ return GetStrProperty(IPROP_RESUSER1, x); }
	CString GetResUser2(int x)			{ return GetStrProperty(IPROP_RESUSER2, x); }
	CString GetResUser3(int x)			{ return GetStrProperty(IPROP_RESUSER3, x); }
	CString GetResUser4(int x)			{ return GetStrProperty(IPROP_RESUSER4, x); }
	int  GetResLineHeight(int x)		{ return (int)GetNumProperty(IPROP_RESLINEHEIGHT, x); }
	long GetResBackColor(int x) 		{ return GetNumProperty(IPROP_RESBACKCOLOR, x); }
	long GetResFontColor(int x) 		{ return GetNumProperty(IPROP_RESFONTCOLOR, x); }
	CString GetResFontName(int x) 		{ char szBuf[81]; FontName((int)GetNumProperty(IPROP_RESFONTNAME, x), szBuf); return szBuf; }
	int  GetResFontSizePercent(int x) 	{ return (int)GetNumProperty(IPROP_RESFONTSIZEPERCENT, x); }
 	BOOL GetResFontBold(int x)			{ return (BOOL)GetNumProperty(IPROP_RESFONTBOLD, x); }
	BOOL GetResFontItalic(int x) 		{ return (BOOL)GetNumProperty(IPROP_RESFONTITALIC, x); }

	// Resource Method Properties - (Get)    
	BOOL GetResIsEmpty(int x)			{ return (BOOL)GetNumProperty(IPROP_RESISEMPTY, x); }
	int  GetResNextEmpty()				{ return (int)GetNumProperty(IPROP_RESNEXTEMPTY); }

	// TimeBlock Header Properties - (Get)
	long GetTBHdrBackColor() 			{ return GetNumProperty(IPROP_TBHDRBACKCOLOR); }
	int  GetTBHdrBevel() 				{ return (int)GetNumProperty(IPROP_TBHDRBEVEL); }
	long GetTBHdrGridColor() 			{ return GetNumProperty(IPROP_TBHDRGRIDCOLOR); }
	int  GetTBHdrHeight()				{ return (int)GetNumProperty(IPROP_TBHDRHEIGHT); }
    
	// TimeBlock Column Properties - (Get)
	int  GetTBColMax() 					{ return (int)GetNumProperty(IPROP_TBCOLMAX); }
	int  GetTBColField(int x) 			{ return (int)GetNumProperty(IPROP_TBCOLFIELD, x); }
	CString GetTBColFormat(int x) 		{ return GetStrProperty(IPROP_TBCOLFORMAT, x); }
	CString GetTBColLabel(int x) 		{ return GetStrProperty(IPROP_TBCOLLABEL, x); }
	int  GetTBColWidth(int x)			{ return (int)GetNumProperty(IPROP_TBCOLWIDTH, x); }
	int  GetTBColAlignment(int x) 		{ return (int)GetNumProperty(IPROP_TBCOLALIGNMENT, x); }
	BOOL GetTBColVisible(int x) 		{ return (BOOL)GetNumProperty(IPROP_TBCOLVISIBLE, x); }
	BOOL GetTBColFrozen(int x)			{ return (BOOL)GetNumProperty(IPROP_TBCOLFROZEN, x); }
	BOOL GetTBColEditable(int x) 		{ return (BOOL)GetNumProperty(IPROP_TBCOLEDITABLE, x); }
	BOOL GetTBColResizable(int x) 		{ return (BOOL)GetNumProperty(IPROP_TBCOLRESIZABLE, x); }
    
	// TimeBlock List Properties - (Get)
	int  GetTBMax() 					{ return (int)GetNumProperty(IPROP_TBMAX); }
	int  GetTBHeight() 					{ return (int)GetNumProperty(IPROP_TBHEIGHT); }
	int  GetTBLineHeight() 				{ return (int)GetNumProperty(IPROP_TBLINEHEIGHT); }
	int  GetTBView() 					{ return (int)GetNumProperty(IPROP_TBVIEW); }
	int  GetTBWidth() 					{ return (int)GetNumProperty(IPROP_TBWIDTH); }
	long GetTBBackColor()				{ return GetNumProperty(IPROP_TBBACKCOLOR); }
	int  GetTBBevel() 					{ return (int)GetNumProperty(IPROP_TBBEVEL); }
	long GetTBGridColor() 				{ return GetNumProperty(IPROP_TBGRIDCOLOR); }
	long GetTBFontColor() 				{ return GetNumProperty(IPROP_TBFONTCOLOR); }
	CString GetTBFontName() 			{ char szBuf[81]; FontName((int)GetNumProperty(IPROP_TBFONTNAME), szBuf); return szBuf; }
	int  GetTBFontSizePercent() 		{ return (int)GetNumProperty(IPROP_TBFONTSIZEPERCENT); }
 	BOOL GetTBFontBold()				{ return (BOOL)GetNumProperty(IPROP_TBFONTBOLD); }
	BOOL GetTBFontItalic() 				{ return (BOOL)GetNumProperty(IPROP_TBFONTITALIC); }
    
	// TimeBlock Array Properties - (Get)
	int  GetTBResource(int x)			{ return (int)GetNumProperty(IPROP_TBRESOURCE, x); }
	CString GetTBBeg(int x)				{ return GetStrProperty(IPROP_TBBEG, x); }
	CString GetTBEnd(int x)				{ return GetStrProperty(IPROP_TBEND, x); }
	CString GetTBDur(int x)				{ return GetStrProperty(IPROP_TBDUR, x); }
	int  GetTBBar(int x)				{ return (int)GetNumProperty(IPROP_TBBAR, x); }
	int  GetTBGroup(int x)				{ return (int)GetNumProperty(IPROP_TBGROUP, x); }
	CString GetTBUser1(int x)			{ return GetStrProperty(IPROP_TBUSER1, x); }
	CString GetTBUser2(int x)			{ return GetStrProperty(IPROP_TBUSER2, x); }
	CString GetTBUser3(int x)			{ return GetStrProperty(IPROP_TBUSER3, x); }
	CString GetTBUser4(int x)			{ return GetStrProperty(IPROP_TBUSER4, x); }
    
	// TimeBlock Method Properties - (Get)
	BOOL GetTBIsEmpty(int x)			{ return (BOOL)GetNumProperty(IPROP_TBISEMPTY, x); }
	int  GetTBNextEmpty()				{ return (int)GetNumProperty(IPROP_TBNEXTEMPTY); }
    
	// Schedule Bar Area Properties - (Get)
	long GetSchedBackColor() 			{ return GetNumProperty(IPROP_SCHEDBACKCOLOR); }
	int  GetSchedBevel() 				{ return (int)GetNumProperty(IPROP_SCHEDBEVEL); }
	long GetSchedGridColor() 			{ return GetNumProperty(IPROP_SCHEDGRIDCOLOR); }
	int  GetSchedGridThickness() 		{ return (int)GetNumProperty(IPROP_SCHEDGRIDTHICKNESS); }

	// Legend Properties - (Get)
	CString GetLegendTitle()			{ return GetStrProperty(IPROP_LEGENDTITLE); }
	int  GetLegendPosition() 			{ return (int)GetNumProperty(IPROP_LEGENDPOSITION); }
	int  GetLegendType() 				{ return (int)GetNumProperty(IPROP_LEGENDTYPE); }
	int  GetLegendSize() 				{ return (int)GetNumProperty(IPROP_LEGENDSIZE); }
	int  GetLegendLineHeight() 			{ return (int)GetNumProperty(IPROP_LEGENDLINEHEIGHT); }
	long GetLegendBackColor() 			{ return GetNumProperty(IPROP_LEGENDBACKCOLOR); }
	int  GetLegendBevel() 				{ return (int)GetNumProperty(IPROP_LEGENDBEVEL); }
	int  GetLegendView() 				{ return (int)GetNumProperty(IPROP_LEGENDVIEW); }
	int  GetLegendSelection() 			{ return (int)GetNumProperty(IPROP_LEGENDSELECTION); }
	BOOL GetLegendResize() 				{ return (BOOL)GetNumProperty(IPROP_LEGENDRESIZE); }
    
	// Print Properties - (Get)
	float GetPrintLeftMargin()			{ return (float)GetFloatProperty(IPROP_PRINTLEFTMARGIN); }
	float GetPrintTopMargin()			{ return (float)GetFloatProperty(IPROP_PRINTTOPMARGIN); }
	float GetPrintRightMargin()			{ return (float)GetFloatProperty(IPROP_PRINTRIGHTMARGIN); }
	float GetPrintBottomMargin()		{ return (float)GetFloatProperty(IPROP_PRINTBOTTOMMARGIN); }
	float GetPrintWidth()				{ return (float)GetFloatProperty(IPROP_PRINTWIDTH); }
	float GetPrintHeight()				{ return (float)GetFloatProperty(IPROP_PRINTHEIGHT); }
	int   GetPrintHeader()				{ return (int)GetNumProperty(IPROP_PRINTHEADER); }
	float GetPrintHeaderHeight()		{ return (float)GetFloatProperty(IPROP_PRINTHEADERHEIGHT); }
	CString GetPrintHeaderText()		{ return GetStrProperty(IPROP_PRINTHEADERTEXT); }
	float GetPrintHeaderTextHeight() 	{ return (float)GetFloatProperty(IPROP_PRINTHEADERTEXTHEIGHT); }
	int   GetPrintFooter()				{ return (int)GetNumProperty(IPROP_PRINTFOOTER); }
	float GetPrintFooterHeight()		{ return (float)GetFloatProperty(IPROP_PRINTFOOTERHEIGHT); }
	CString GetPrintFooterText()		{ return GetStrProperty(IPROP_PRINTFOOTERTEXT); }
	float GetPrintFooterTextHeight() 	{ return (float)GetFloatProperty(IPROP_PRINTFOOTERTEXTHEIGHT); }
	BOOL GetPrintShowDialog() 			{ return (BOOL)GetNumProperty(IPROP_PRINTSHOWDIALOG); }


	// DLL Calls

	// AddBar - adds a bar definition to the Bar Array
	int AddBar(int iIndex, LPCSTR szBarName,
				int iSizePercent, int iOffsetPercent, 
				long lColor, int iPattern, int iAdjustable,
				int iTextPos, int iTextField, LPCSTR szTextFormat, int iTextClip,
				long lFontColor, LPCSTR szFontName, int iFontSizePercent,
				int iFontBold, int iFontItalic,
				int iBegSymbol, int iBegType, long lBegColor,
				int iBegSizePercent, int iBegOffsetPercent,
				int iEndSymbol, int iEndType, long lEndColor,
				int iEndSizePercent, int iEndOffsetPercent )
	{
		int (FAR PASCAL *lpfnAddBar) (HCTL, int, LPCSTR, int,
				int, long, int, int, int, int, LPCSTR, int,
				long, LPCSTR, int, int, int, int, int, long,
				int, int, int, int, long, int, int);

	    lpfnAddBar = (int (FAR PASCAL *)(HCTL, int, LPCSTR, int,
				int, long, int, int, int, int, LPCSTR, int,
				long, LPCSTR, int, int, int, int, int, long,
				int, int, int, int, long, int, int))
        			GetProcAddress(GetHInstance(), "SchedVBXAddBar");

    	if (lpfnAddBar == NULL)
    		return -1;

		return ((*lpfnAddBar) (m_hCtl, iIndex, szBarName,
				iSizePercent, iOffsetPercent, lColor, iPattern,
				iAdjustable, iTextPos, iTextField, szTextFormat,
				iTextClip, lFontColor, szFontName, iFontSizePercent,
				iFontBold, iFontItalic,
				iBegSymbol, iBegType, lBegColor, iBegSizePercent, iBegOffsetPercent,
				iEndSymbol, iEndType, lEndColor, iEndSizePercent, iEndOffsetPercent ));
	}

	// AddResource - Adds a resource definition to the Resource Array
	int AddResource(int iIndex, LPCSTR szResourceName,
				int iBarDefault, LPCSTR szUser1, LPCSTR szUser2,
				LPCSTR szUser3, LPCSTR szUser4,
				int iLineHeight, long lBackColor, long lFontColor,
				LPCSTR szFontName, int iFontSizePercent,
				int iFontBold, int iFontItalic )
	{
		int (FAR PASCAL *lpfnAddResource) (HCTL, int, LPCSTR, int,
				LPCSTR, LPCSTR, LPCSTR, LPCSTR, int, long, long,
				LPCSTR, int, int, int);

	    lpfnAddResource = (int (FAR PASCAL *)(HCTL, int, LPCSTR, int,
				LPCSTR, LPCSTR, LPCSTR, LPCSTR, int, long, long,
				LPCSTR, int, int, int))
        			GetProcAddress(GetHInstance(), "SchedVBXAddResource");

    	if (lpfnAddResource == NULL)
    		return -1;

		return ((*lpfnAddResource) (m_hCtl, iIndex, szResourceName,
				iBarDefault, szUser1, szUser2, szUser3, szUser4,
				iLineHeight, lBackColor, lFontColor,
				szFontName, iFontSizePercent, iFontBold, iFontItalic ));
	}

	// AddTimeBlock - Adds a timeblock definition to the TimeBlock Array
	int AddTimeBlock(int iIndex, int iResource,
					LPCSTR szBeg, LPCSTR szEnd, LPCSTR szDur,
					int iBar, int iGroup, LPCSTR szUser1,
					LPCSTR szUser2, LPCSTR szUser3, LPCSTR szUser4 )
	{
		int (FAR PASCAL *lpfnAddTimeBlock) (HCTL, int, int,
					LPCSTR, LPCSTR, LPCSTR, int, int,
					LPCSTR, LPCSTR, LPCSTR, LPCSTR );

	    lpfnAddTimeBlock = (int (FAR PASCAL *)(HCTL, int, int,
					LPCSTR, LPCSTR, LPCSTR, int, int,
					LPCSTR, LPCSTR, LPCSTR, LPCSTR ))
        			GetProcAddress(GetHInstance(), "SchedVBXAddTimeBlock");

    	if (lpfnAddTimeBlock == NULL)
    		return -1;

		return ((*lpfnAddTimeBlock) (m_hCtl, iIndex, iResource,
					szBeg, szEnd, szDur, iBar, iGroup,
					szUser1, szUser2, szUser3, szUser4 ));
	}

	// FindTimeBlock - Finds a TimeBlock for a Resource
	int FindTimeBlock(int iBegTB, int iResource)
	{
		int (FAR PASCAL *lpfnFindTimeBlock) (HCTL, int, int);

	    lpfnFindTimeBlock = (int (FAR PASCAL *)(HCTL, int, int))
        			GetProcAddress(GetHInstance(), "SchedVBXFindTimeBlock");

    	if (lpfnFindTimeBlock == NULL)
    		return -1;

		return ((*lpfnFindTimeBlock) (m_hCtl, iBegTB, iResource));
	}

	// FindFreeTimeBlock - Finds a free TimeBlock for a Resource
	int FindFreeTimeBlock(int iResource, LPCSTR szBeg, LPCSTR szDur)
	{
		int (FAR PASCAL *lpfnFindFreeTimeBlock) (HCTL, int, LPCSTR, LPCSTR);

	    lpfnFindFreeTimeBlock = (int (FAR PASCAL *)(HCTL, int, LPCSTR, LPCSTR))
        			GetProcAddress(GetHInstance(), "SchedVBXFindFreeTimeBlock");

    	if (lpfnFindFreeTimeBlock == NULL)
    		return -1;

		return ((*lpfnFindFreeTimeBlock) (m_hCtl, iResource, szBeg, szDur));
	}

	// ResourceNum - Returns a Resource Number based on Resource Name
	int ResourceNum(LPCSTR szResourceName)
	{
		int (FAR PASCAL *lpfnResourceNum) (HCTL, LPCSTR);

	    lpfnResourceNum = (int (FAR PASCAL *)(HCTL, LPCSTR))
        			GetProcAddress(GetHInstance(), "SchedVBXResourceNum");

    	if (lpfnResourceNum == NULL)
    		return -1;

		return ((*lpfnResourceNum) (m_hCtl, szResourceName));
	}

	// PointToTime - Converts a Point (X/Y) to a Time Value
	int PointToTime(int iX, int iY, LPSTR szTime)
	{
		int (FAR PASCAL *lpfnPointToTime) (HCTL, int, int, LPSTR);

	    lpfnPointToTime = (int (FAR PASCAL *)(HCTL, int, int, LPSTR))
        			GetProcAddress(GetHInstance(), "SchedVBXPointToTime");

    	if (lpfnPointToTime == NULL)
    		return -1;

		return ((*lpfnPointToTime) (m_hCtl, iX, iY, szTime));
	}

	// TimeToPoint - Converts a Time Value to a Point (X/Y)
	int TimeToPoint(LPCSTR szTime, int FAR *iX, int FAR *iY)
	{
		int (FAR PASCAL *lpfnTimeToPoint) (HCTL, LPCSTR, int FAR *, int FAR *);

	    lpfnTimeToPoint = (int (FAR PASCAL *)(HCTL, LPCSTR, int FAR *, int FAR *))
        			GetProcAddress(GetHInstance(), "SchedVBXTimeToPoint");

    	if (lpfnTimeToPoint == NULL)
    		return -1;

		return ((*lpfnTimeToPoint) (m_hCtl, szTime, iX, iY));
	}

	// PointToResource - Converts a Point (X/Y) to a Resource Number
	int PointToResource(int iX, int iY)
	{
		int (FAR PASCAL *lpfnPointToResource) (HCTL, int, int);

	    lpfnPointToResource = (int (FAR PASCAL *)(HCTL, int, int))
        			GetProcAddress(GetHInstance(), "SchedVBXPointToResource");

    	if (lpfnPointToResource == NULL)
    		return -1;

		return ((*lpfnPointToResource) (m_hCtl, iX, iY));
	}

	// ResourceToPoint - Converts a Resource Number to a Point (X/Y)
	int ResourceToPoint(int iResource, int FAR *iX, int FAR *iY)
	{
		int (FAR PASCAL *lpfnResourceToPoint) (HCTL, int, int FAR *, int FAR *);

	    lpfnResourceToPoint = (int (FAR PASCAL *)(HCTL, int, int FAR *, int FAR *))
        			GetProcAddress(GetHInstance(), "SchedVBXResourceToPoint");

    	if (lpfnResourceToPoint == NULL)
    		return -1;

		return ((*lpfnResourceToPoint) (m_hCtl, iResource, iX, iY));
	}

	// PointToLegend - Converts a Point (X/Y) to a Legend List Number
	int PointToLegend(int iX, int iY)
	{
		int (FAR PASCAL *lpfnPointToLegend) (HCTL, int, int);

	    lpfnPointToLegend = (int (FAR PASCAL *)(HCTL, int, int))
        			GetProcAddress(GetHInstance(), "SchedVBXPointToLegend");

    	if (lpfnPointToLegend == NULL)
    		return -1;

		return ((*lpfnPointToLegend) (m_hCtl, iX, iY));
	}

	// LegendToPoint - Converts a Legend List Number to a Point (X/Y)
	int LegendToPoint(int iLegend, int FAR *iX, int FAR *iY)
	{
		int (FAR PASCAL *lpfnLegendToPoint) (HCTL, int, int FAR *, int FAR *);

	    lpfnLegendToPoint = (int (FAR PASCAL *)(HCTL, int, int FAR *, int FAR *))
        			GetProcAddress(GetHInstance(), "SchedVBXLegendToPoint");

    	if (lpfnLegendToPoint == NULL)
    		return -1;

		return ((*lpfnLegendToPoint) (m_hCtl, iLegend, iX, iY));
	}

	// PointToBar - Converts a Point (X/Y) to a Bar #
	//		returns position of point on bar & sets TimeBlock #
	int PointToBar(int iX, int iY, int FAR *iTimeBlock)
	{
		int (FAR PASCAL *lpfnPointToBar) (HCTL, int, int, int FAR *);

	    lpfnPointToBar = (int (FAR PASCAL *)(HCTL, int, int, int FAR *))
        			GetProcAddress(GetHInstance(), "SchedVBXPointToBar");

    	if (lpfnPointToBar == NULL)
    		return -1;

		return ((*lpfnPointToBar) (m_hCtl, iX, iY, iTimeBlock));
	}

	// FontNum - returns Font # based on Font Name
	int FontNum(LPCSTR szFontName)
	{
		int (FAR PASCAL *lpfnFontNum) (HCTL, LPCSTR);

	    lpfnFontNum = (int (FAR PASCAL *)(HCTL, LPCSTR))
        			GetProcAddress(GetHInstance(), "SchedVBXFontNum");

    	if (lpfnFontNum == NULL)
    		return -1;

		return ((*lpfnFontNum) (m_hCtl, szFontName));
	}

	// FontName - returns Font Name based on Font #
	int FontName(int iFontNum, LPSTR szFontName)
	{
		int (FAR PASCAL *lpfnFontName) (HCTL, int, LPSTR);

	    lpfnFontName = (int (FAR PASCAL *)(HCTL, int, LPSTR))
        			GetProcAddress(GetHInstance(), "SchedVBXFontNum");

    	if (lpfnFontName == NULL)
    		return -1;

		return ((*lpfnFontName) (m_hCtl, iFontNum, szFontName));
	}


	// Event Parameter extraction routines
	
	// Fetches a string parameter from event stack
	BOOL GetEventParamString(LPVOID data, int iIndex, LPSTR lpstr) {
		BOOL (FAR PASCAL *lpfnGetEventParamString) (LPVOID, int, LPSTR);

	    lpfnGetEventParamString = (BOOL (FAR PASCAL *)(LPVOID, int, LPSTR))
        	GetProcAddress(GetHInstance(), "SchedVBXGetEventParamString");

    	if (lpfnGetEventParamString == NULL) {
    		*lpstr = 0;
    		return FALSE;
    	}

		return ((*lpfnGetEventParamString) (data, iIndex, lpstr));
	}

	// Fetches an int parameter from event stack
	BOOL GetEventParamInt(LPVOID data, int iIndex, int FAR *iPtr) {
		int (FAR PASCAL *lpfnGetEventParamInt) (LPVOID, int);

	    lpfnGetEventParamInt = (int (FAR PASCAL *)(LPVOID, int))
        	GetProcAddress(GetHInstance(), "SchedVBXGetEventParamInt");

    	if (lpfnGetEventParamInt == NULL) {
    		*iPtr = 0;
    		return FALSE;
    	}

		*iPtr = ((*lpfnGetEventParamInt) (data, iIndex));
		
		return TRUE;
	}
	
protected:
};

#endif
